{

    SnakeASCII.lpr                     last modified: 2 July 2014

    Copyright (C) Jaroslaw Baran, furious programming 2011 - 2014.
    All rights reserved.
   __________________________________________________________________________

    This unit is a part of the SnakeASCII console game.
   __________________________________________________________________________

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program. If not, see <http://www.gnu.org/licenses/>.
   __________________________________________________________________________

}

program SnakeASCII;

{$MODE OBJFPC}{$H+}

uses
  {$IFDEF WINDOWS} Windows, {$ENDIF}{$IFDEF UNIX} cwstring, {$ENDIF} Crt, Game;

{$R *.res}

var
  gmSnake: TGame;
begin
  {$IFDEF WINDOWS}
  { set console output code page }
  SetConsoleOutputCP(CP_UTF8);
  {$ENDIF}

  try
    { run the randomizing machine }
    Randomize();
    { initialize console for the game }
    CursorOff();
    ClrScr();

    { create game class }
    gmSnake := TGame.Create();
    { play the snake game }
    gmSnake.Play();
  finally
    { free the game class }
    gmSnake.Free();

    { restore console preferences }
    CursorOn();
    ClrScr();
  end;
end.

