{

    Timer.pp                           last modified: 2 July 2014

    Copyright (C) Jaroslaw Baran, furious programming 2011 - 2014.
    All rights reserved.
   __________________________________________________________________________

    This unit is a part of the SnakeASCII console game.
   __________________________________________________________________________

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program. If not, see <http://www.gnu.org/licenses/>.
   __________________________________________________________________________

}

unit Timer;

{$MODE OBJFPC}{$H+}

interface

uses
  Crt, Common;


type
  TTimer = class(TObject)
  private
    FStepsCount: UInt8;
    FMaxStepsCount: UInt8;
  public
    constructor Create();
    destructor Destroy(); override;
  public
    procedure Step();
    procedure Reset();
    function ItsTime(): Boolean;
  public
    property MaxStepsCount: UInt8 read FMaxStepsCount write FMaxStepsCount;
  end;


{ ----- end interface ----------------------------------------------------------------------------------------- }


implementation


constructor TTimer.Create();
begin
  inherited Create();

  { initialize the steps counter }
  FStepsCount := TIMER_ZERO_STEP;
end;


destructor TTimer.Destroy();
begin
  inherited Destroy();
end;


procedure TTimer.Step();
begin
  { check the current steps count }
  if FStepsCount = FMaxStepsCount then
    { zero the counter }
    FStepsCount := TIMER_ZERO_STEP;

  { increment the steps count }
  Inc(FStepsCount);
  { sleep the frame }
  Delay(SINGLE_FRAME_DELAY_TIME);
end;


procedure TTimer.Reset();
begin
  { clear the steps count }
  FStepsCount := TIMER_ZERO_STEP;
end;


function TTimer.ItsTime(): Boolean;
begin
  { compare steps count with the maximum cycles count }
  Result := FStepsCount = FMaxStepsCount;
end;


{ ----- end implementation ------------------------------------------------------------------------------------ }


end.

